
;****************************************************************
; waitIO: a few nops so Hardware can recover
;****************************************************************

waitIO:                ; just a 45 nop's loop..
	moveq	#44,d0
\wait
	nop
	dbra	d0,\wait
	rts

;****************************************************************
; anticrash_handler : one handler for one 'protected' vector
;****************************************************************

anticrash_handlers:
ADRERROR
	move.w	#$2700,SR
	lea	adrerr(pc),a0
	bra.w	crash
ILLEGALI
	move.w	#$2700,SR
	lea	illerr(pc),a0
	bra.w	crash
zeroz
	move.w	#$2700,SR
	lea	zero(pc),a0
	bra.w	crash
chkiz
	move.w	#$2700,SR
	lea	chki(pc),a0
	bra.w	crash
trapviz
	move.w	#$2700,SR
	lea	trapvi(pc),a0
	bra.w	crash
priviz
	move.w	#$2700,SR
	lea	privi(pc),a0
	bra.w	crash
tracez
	move.w	#$2700,SR
	lea	trace(pc),a0
	bra.w	crash
line11z
	move.w	#$2700,SR
	lea	line11(pc),a0
	bra.w	crash
spurz
	move.w	#$2700,SR
	lea	spur(pc),a0
	bra.w	crash
memviol
	move.w	#$2700,SR
	lea	mem(pc),a0
	bra.w	crash
tr5z
	move.w	#$2700,SR
	lea	tr5(pc),a0
	bra.w	crash
tr6z
	move.w	#$2700,SR
	lea	tr6(pc),a0
	bra.w	crash
tr7z
	move.w	#$2700,SR
	lea	tr7(pc),a0
	bra.w	crash
tr13z
	move.w	#$2700,SR
	lea	tr13(pc),a0
	bra.w	crash
tr14z
	move.w	#$2700,SR
	lea	tr14(pc),a0
	bra.w	crash
tr15z
	move.w	#$2700,SR
	lea	tr15(pc),a0
	bra.w	crash
STOON
	move.w	#$2700,SR
	movem.l	d0-d7/a0-a6,-(a7)
	tst.w	anticrash_running	; is STO-ON handler is already running
	bne	\cont			; we don't call it again

	move.w	$4,d0
	cmp.w	#$40,d0
	bge	\92test

	move.w	#$FFDF,$600018
	bsr	waitIO		; Waits some time for the IO to recover
	btst.b	#1,$60001B	; tests the STO key
	beq	\ABORT		; pressed -> abort
	bra	\cont		; else go on

\92test
	move.w	#$3F7,$600018
	bsr	waitIO		; Waits some time for the IO to recover
	btst.b	#0,$60001B	; tests the STO key
	bne	\cont		; not pressed -> go on

\ABORT
	movem.l	(a7)+,d0-d7/a0-a6	; pops all regs
	lea	abort(pc),a0		; loads the error message
	bra.s	crash			; acts like a crash

\cont
	movem.l	(a7)+,d0-d7/a0-a6		; pops regs
	move.l	(saved_addresses+4*16)(pc),-(a7)	; pushes the old Auto Int 6 adress
	rts				; exits

crash:	
	move.l	a0,error_string
	move.w	#$700,SR	; user mode, ints off
	dc.w	$A006		; Throw Error : "Assembly crash"

