/* Programme pour remplacer INCBIN pour la compilation de DoorsOS
 *  par Frdric JOUAULT, le 01/05/2000 pour ne pas fatiguer Xavier Vassor. */

#include <stdio.h>

#define MAXBYTES 30000 // a moins que le kernel fasse plus de 30000 octets...

unsigned char Buffer[MAXBYTES];

int main(int argc, char ** argv) {
        FILE * in, * out;
        int size, i;

        if(argc != 3) {
                fprintf(stderr, "Syntaxe :\n\tbin2c <destination file> <source file>\n\n");
                return 1;
        }

        if(!(in = fopen(argv[2], "rb"))) {
                fprintf(stderr, "Impossible d'ouvrir le fichier source !\n\n");
                return 1;
        }

        if(!(out = fopen(argv[1], "w"))) {
                fprintf(stderr, "Impossible d'ouvrir le fichier destination !\n\n");
                return 1;
        }

        fprintf(out, "unsigned char kernel_bin[] = {\n");

        size = fread(Buffer, 1, MAXBYTES, in);

        for(i = 0 ; i < size - 1; i++) {
              fprintf(out, "0x%02X,", Buffer[i]);
              if(!((i + 1) % 10))
                      fprintf(out, "\n");
              else
                      fprintf(out, " ");
        }
        fprintf(out, "0x%02X", Buffer[i]);


        fprintf(out, "\n};\n");

        fclose(in);
        fclose(out);

        return 0;
}
