; Thanks to David Kuhling for this part


SaveHeapState:
	move.l		4(a7),a0	; a0 = ptr to heap table
	movem.l	d0-d7/a0-a6,-(a7)
	move.l		(a0),a6		; a6 = heap table
	lea		HandleInfo(pc),a0	; a0 = pointer to handle-info-table
	move.w		#999,d7	; d7 = number of handles we save the state of


;    ************* get-Handle-Info-Loop ************
;	Thanks to David Kuhling

	moveq		#1,d1            ; d1 = bit mask
\SetLp
	tst.l	(a6)+		; this handle is allocated ?
	beq	\_NotA
	or.b	d1,(a0)	;  -> set corresponding bit within the info-table
\_NotA
	rol.b	#1,d1		; go to next bit
	bcc	\_NoNB		; next bit is within the next byte ?
	addq.l	#1,a0		;  -> go to the next byte (info-table)
\_NoNB	dbra	d7,\SetLp	; loop 1000 times
	movem.l	(a7)+,d0-d7/a0-a6
	rts

RestoreHeapState:
	move.l	4(a7),a0
	move.w	8(a7),d0
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	(a0),a6		; a6 = pointer to handle table
	move.w	d0,d4			; d4 = handle of the folder table
	lea	HandleInfo(pc),a2	; a2 = pointer to handle-info-table


	move.w	#999,d7        ; d7 = number of handles
	clr.b	d2            ; d2 = bit number = 0
	clr.w	d3            ; d3 = handle number = 0

;    ************** check-handles-loop *************
\ChkLp
	tst.l	(a6)+		; handle is allocated ?
	beq	\_HdOK		; NO -> OK
	btst.b	d2,(a2)	;  -> handle was not allocated before ?
	bne	\_HdOK		; was allocated before -> OK

; Then see if this handle is in VAT (it is a file or a folder)
; if NO, free it
	bsr		free_non_VAT_handle

\_HdOK	addq.w	#1,d3            ; increase handle number
	addq.b	#1,d2            ; increase bit number
	cmpi.b	#8,d2            ; bit number == 8 ?
	bne	\_NoNB
	addq.l	#1,a2            ;  -> go to next byte in handle-info-table
	clr.b	d2            ;  -> go to first bit within this byte
\_NoNB
	dbra	d7,\ChkLp
	movem.l	(a7)+,d0-d7/a0-a6
	rts


free_non_VAT_handle:
;Input :
;	d3.w = handle to search
;	d4.w = handle of the folder list

	movem.l	d0-d7/a0-a6,-(a7)

	move.l	$C8,a0
	move.w	d4,-(sp)
	move.l	600(a0),a0
	jsr	(a0)		; Deref
	lea	4(a0),a2
	addq.l	#2,sp

	move.w	2(a0),d4	; nb folders
	tst.w	d4
	beq	.L189
	subq.w #1,d4
.L190:
	move.l $C8,a0
	move.w 12(a2),d0
	cmp.w	d0,d3		; compare with the handle to search
	beq	.L187
	move.w	d0,-(sp)
	move.l 600(a0),a0
	jsr	(a0)		; Deref
	lea	4(a0),a1
	addq.l	#2,sp
	move.w	2(a0),d0	; nb files
	tst.w	d0
	beq	.L192
	subq.w	#1,d0
.L193:
	cmp.w	12(a1),d3	; compare with the handle to search
	beq	.L187
	lea	14(a1),a1
	dbra	d0,.L193	; browse all files in this folder
.L192:
	lea	14(a2),a2
	dbra	d4,.L190	; browse all folders
.L189:
	move.l	$C8,a0		; not found -> free it
	move.w	d3,-(sp)
	move.l	604(a0),a0
	jsr	(a0)		; Heap Free
	addq.l	#2,sp
.L187:
	movem.l	(a7)+,d0-d7/a0-a6
	rts
