HANDLE screen_handle = 0;

void InitKernel()
{
  int i = NB_VECTORS;
  if (nb_modules)
	return;
// Kernel Initialization needed
// Save screen
  screen_handle = HeapAlloc(3840);
  if (!screen_handle)
    error(memory);
  else
    memcpy(HeapDeref(screen_handle), LCD_MEM, 3840);

// Save state of the heap table
  SaveHeapState(RAM_CALLS[HEAP]);

// Installs Anti-Crash
  SetSR(0x700);
  while (i--)
  {
    ulong **vector = (ulong **)(anticrash_addresses[i]+0x40000);
    saved_addresses[i] = *vector;
    *vector = (ulong *)&anticrash_handlers[i];
  }
  SetSR(0);
}

void DeInitKernel()
{
  int i = NB_VECTORS;
  PortRestore();		// Just in the case a program forgot it..
  re_archive_libs();	// Re-archive unarchived libraries 
  if (nb_modules)
    return;
// DeInstalls Anti-Crash
  SetSR(0x700);
  while (i--)
  {
    ulong **vector = (ulong **)(anticrash_addresses[i]+0x40000);
    *vector = saved_addresses[i];
  }
  SetSR(0);
// Restores the state of the heap table
  RestoreHeapState(RAM_CALLS[HEAP], RAM_CALLS[FOLDERLIST]);
// Restaure l'ecran
  if (screen_handle)
  {
    memcpy(LCD_MEM, HeapDeref(screen_handle), 3840);
    HeapFree(screen_handle);
  }
  return;
}


