#define NOSTUB
typedef unsigned short ushort;
typedef unsigned long ulong;
typedef unsigned char uchar;

int _nostub;

#define _rom_call(type,args,index) \
  ((type(*)args)(*((long*)(*((long*)0xC8)+(0x##index)*4))))

#define INTERRUPT_TABLE	(ulong *) 0x40000
#define RESET_VECTOR	(ulong *) 0x40004
#define AUTO_INTS		(ulong *) 0x40064

#define RELOC 0
#define UNRELOC 1

#define NB_VECTORS	17

#define TI_89	0
#define TI_92	1

#define ROM_VERSION_ERROR	-2
#define KERNEL_VERSION_ERROR	-1
#define NO_ERROR 			0
#define NOT_ENOUGH_MEM		1
#define LIB_NOT_FOUND		2
#define WRONG_LIB_VERSION	3
#define FILE_NOT_VALID		4
#define ARCHIVED_FILE		5
#define CRASH_ERROR			6

#define NB_RAM_CALLS 21

#define CALC		0*2
#define LCDWIDTH	1*2
#define LCD_HEIGTH	2*2
#define ROMbase		3*2
#define LCDLINEBYTES	4*2
#define LEFT		5*2
#define RIGTH		6*2
#define UP			7*2
#define DOWN		8*2
#define UP_RIGTH	9*2
#define DOWN_LEFT	10*2
#define DIAM0ND		11*2
#define LCDSIZE		12*2
#define SHIFT		13*2
#define FONTS		14*2
#define RETURN_VAL	15*2
#define KB_VARS		16*2
#define HEAP		17*2
#define FOLDERLIST	18*2
#define MAINHANDLE	19*2
#define ROM_VER		20*2

typedef struct{
  ushort nboffsets;
  ushort offsets;
}reloc_table;

typedef struct{
  ushort index;
  ushort offsets;	
}function_table;

typedef struct{
  ushort nbfuncs;
  ushort offsets;
}export_table;

typedef struct{
  ushort nbfuncs;
  function_table table;
}func_reloc_table;

typedef struct{
	char name[8];
    short padding;
}lib_name;

typedef struct{
  ushort bsr;
  ushort bsr_offset;
  ulong  sign;
  char  relocating;
  char  relcnt;
  ushort comment_offset;
  ushort main_offset;
  ushort exit_offset;
  ushort flags;
  ushort bss_hdl;
  ushort bss_offset;
  ushort export_offset;
  ushort extraRAM_offset;
  ushort nblibs;
  lib_name libs_names;
}ASM;


typedef struct{
	char handler[12];	// 12 bytes
}anticrash_handler;




