int reloc(HANDLE handle)
{
  return reloc2(HeapDeref(handle)+2);
}

void exit_reloc(ASM* address, int i) // i = nb of libs already relocated
{
  int j;
  SYM_ENTRY *lib_sym;
  lib_name *lib_names;
  lib_names = &address->libs_names;
  for (j=0; j<i; j++)
  {
    lib_sym = cherche_lib(lib_names[j].name);
    unreloc(lib_sym->handle);
    if (address->bss_hdl)
      HeapFree(address->bss_hdl);
  }
}

int reloc_core(ASM *address)
{
  int reloc_result;
// Cree le BSS
  if (address->bss_offset)
  {
    long taille_bss = *(long *)(((void *)address) + address->bss_offset);
    HANDLE bss_hdl = HeapAllocHigh(taille_bss);
    if (!bss_hdl)
      return NOT_ENOUGH_MEM;
    address->bss_hdl = bss_hdl;
  }
  reloc_result = relocation(address, RELOC);
  return reloc_result;
}

int reloc2(ASM *address)
{
  int result;
  if (address >= (ASM *)0x200000)
    return ARCHIVED_FILE;
  if (  (address->sign != 0x36386B50)		// 68kP
  	 && (address->sign != 0x36386B4C) )		// 68kL
  	return FILE_NOT_VALID;

  if (address->relocating)
    return NO_ERROR;

  if (address->relcnt)  // Already relocated
  {
    address->relcnt++;
    nb_modules++;
    return NO_ERROR;
  }

  SetSR(0x700);
  address->relocating = 1;
  HeapLock(HeapPtrToHandle((void *)address-2));
  result = reloc_core(address);
  address->relocating = 0;
  SetSR(0);

  if (result > 0)
    return result;

  address->relcnt++;
  nb_modules++;
  if (result < 0)
    unreloc2(address);

  return result;
}
